package com.link.base.basic.service;

import com.link.base.basic.dao.mybatis.mapper.BasicCommonMapper;
import com.link.base.basic.model.ListOfValue;
import com.link.core.basic.dao.mapper.BasicMapper;
import com.link.core.basic.service.BasicServiceImpl;
import javax.annotation.Resource;
import org.springframework.stereotype.Service;

@Service
public class BasicCommonServiceImpl extends BasicServiceImpl<ListOfValue> implements BasicCommonService {
   @Resource
   private BasicCommonMapper basicCommonMapper;
   @Resource
   private BaseDutyPostnService baseDutyPostnService;

   public BasicMapper<ListOfValue> getBasicMapper() {
      return this.basicCommonMapper;
   }

   public ListOfValue preDefaultValue(ListOfValue entity) throws Exception {
      ListOfValue record = new ListOfValue();
      record.setLangId("CHS");
      record.setActiveFlag("Y");
      record.setCorpid(record.getLoginCorpId());
      return record;
   }

   public ListOfValue getLovByNameAndType(String stype, String val) throws Exception {
      ListOfValue entity = new ListOfValue();
      entity.setVal(val);
      entity.setType(stype);
      return this.basicCommonMapper.queryLovByValAndType(entity);
   }

   public ListOfValue getLovName(ListOfValue entity) throws Exception {
      return this.basicCommonMapper.getLovName(entity);
   }

   public ListOfValue getLovVal(ListOfValue entity) throws Exception {
      return this.basicCommonMapper.getLovVal(entity);
   }

   public String getLovVal(String type, String name) throws Exception {
      ListOfValue example = new ListOfValue();
      example.setLang("chs");
      example.setName(name);
      example.setType(type);
      ListOfValue result = this.basicCommonMapper.getLovVal(example);
      return result.getVal();
   }

   public void afterInsert(ListOfValue entity) throws Exception {
      String type = "POSTN_TYPE";
      if (type.equalsIgnoreCase(entity.getType())) {
         this.baseDutyPostnService.insertByListOfVal(entity);
      }

   }

   public void beforDelete(ListOfValue entity) throws Exception {
      String type = "POSTN_TYPE";
      if (type.equalsIgnoreCase(entity.getType())) {
         this.baseDutyPostnService.deleteByValId(entity);
      }

   }
}
